Package java.io

## Class OutputStreamWriter

- java.lang.Object
- - java.io.Writer
  - - java.io.OutputStreamWriter

- All Implemented Interfaces:
    `Closeable`, `Flushable`, `Appendable`, `AutoCloseable`

      public class OutputStreamWriter
      extends Writer

  An OutputStreamWriter is a bridge from character streams to byte streams: Characters written to it are encoded into bytes using a specified `charset`. The charset that it uses may be specified by name or may be given explicitly, or the platform's default charset may be accepted.

  Each invocation of a write() method causes the encoding converter to be invoked on the given character(s). The resulting bytes are accumulated in a buffer before being written to the underlying output stream. The size of this buffer may be specified, but by default it is large enough for most purposes. Note that the characters passed to the write() methods are not buffered.

  See Also:
    `OutputStream`

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `OutputStreamWriter​(OutputStream out)` | Creates an OutputStreamWriter that uses the default character encoding.
    `OutputStreamWriter​(OutputStream out, String charsetName)` | Creates an OutputStreamWriter that uses the named charset.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the stream.
    `void` | `flush()` | Flushes the stream.
    `String` | `getEncoding()` | Returns the name of the character encoding being used by this stream.
    `void` | `write​(char[] cbuf, int off, int len)` | Writes a portion of an array of characters.
    `void` | `write​(int c)` | Writes a single character.
    `void` | `write​(String str, int off, int len)` | Writes a portion of a string.

    - ### Methods inherited from class java.io.Writer

      `append, append, append, write, write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### OutputStreamWriter

          public OutputStreamWriter​(OutputStream out)

      Creates an OutputStreamWriter that uses the default character encoding.
      Parameters:
        `out` - An OutputStream

    - #### OutputStreamWriter

          public OutputStreamWriter​(OutputStream out,
                                    String charsetName)
                             throws UnsupportedEncodingException

      Creates an OutputStreamWriter that uses the named charset.
      Parameters:
        `out` - An OutputStream
        `charsetName` - The name of a supported `charset`
      Throws:
        `UnsupportedEncodingException` - If the named encoding is not supported

  - ### Method Detail

    - #### close

          public void close()
                     throws IOException

      Close the stream.
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in class `Writer`
      Throws:
        `IOException` - If an I/O error occurs

    - #### flush

          public void flush()
                     throws IOException

      Flushes the stream.
      Specified by:
        `flush` in interface `Flushable`
      Specified by:
        `flush` in class `Writer`
      Throws:
        `IOException` - If an I/O error occurs

    - #### getEncoding

          @Nullable
          public String getEncoding()

      Returns the name of the character encoding being used by this stream.

      If the encoding has an historical name then that name is returned; otherwise the encoding's canonical name is returned.

      If this instance was created with the `OutputStreamWriter(OutputStream, String)` constructor then the returned name, being unique for the encoding, may differ from the name passed to the constructor. This method may return `null` if the stream has been closed.

      Returns:
        The historical name of this encoding, or possibly `null` if the stream has been closed

    - #### write

          public void write​(char[] cbuf,
                            int off,
                            int len)
                     throws IOException

      Writes a portion of an array of characters.
      Specified by:
        `write` in class `Writer`
      Parameters:
        `cbuf` - Buffer of characters
        `off` - Offset from which to start writing characters
        `len` - Number of characters to write
      Throws:
        `IOException` - If an I/O error occurs

    - #### write

          public void write​(int c)
                     throws IOException

      Writes a single character.
      Overrides:
        `write` in class `Writer`
      Parameters:
        `c` - int specifying a character to be written
      Throws:
        `IOException` - If an I/O error occurs

    - #### write

          public void write​(String str,
                            int off,
                            int len)
                     throws IOException

      Writes a portion of a string.
      Overrides:
        `write` in class `Writer`
      Parameters:
        `str` - A String
        `off` - Offset from which to start writing characters
        `len` - Number of characters to write
      Throws:
        `IOException` - If an I/O error occurs